#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>

int sub=0;

char *read_next_line(FILE *fp)
{
	int c;
	int i=0;
	char *retval=NULL;
	while((c=fgetc(fp))!=EOF)
	{
		retval=realloc(retval, i+2);
		retval[i++]=c;
		if(c=='\n') break;
	}
	if(i) retval[i]=0;
	return retval;
}

int formulate(char *c)
{
	int ret=(atoi(c)*0.25521)-sub;

	if(ret<0) return 0;
	else return ret;
}

int read_file(const char *file, const char *sndfile)
{
	FILE *fp=NULL;
	char *data=NULL;
	int start=0;
	char *length=NULL;
	char *last=NULL;

	if(!(fp=fopen(file, "r")))
	{
		fprintf(stderr, "Could not open file: %s\n", strerror(errno));
		return -1;
	}
	while((data=read_next_line(fp)))
	{
		char *begin=NULL;
		char *ep=NULL;
		char *fp=NULL;
		if(!start)
		{
			if(strncmp(data, "===", strlen("==="))==0) start=1;
			free(data);
			continue;
		}
		if(strlen(data)>45)
		{
			data[13]='\0';
			length=&data[7];
			data[33]='\0';
			begin=&data[26];

			if(last) printf("%s:%05d:%05d:\n", sndfile, formulate(last), formulate(begin));
		}
		else if(last)
		{
			data[13]='\0';
			length=&data[7];
			printf("%s:%05d:%05d:\n", sndfile, formulate(last), formulate(length)+sub);
		}

		last=begin;
		free(data);
	}
	if(fclose(fp))
	{
		fprintf(stderr, "Could not close file: %s\n", strerror(errno));
		return -1;
	}
}

int main(int argc, char *argv[])
{
	int i=1;
	sub=atoi(argv[i++]);
	if(read_file(argv[i++], argv[i++])) return 1;
	return 0;
}
